require "defines"


gt = game.gettext

game.oninit(function()

	game.player.force.disableallprototypes()
  	game.player.force.disableresearch()

	glob.sizeX = 50
	glob.sizeY = 50
	glob.maze_origin = {x = 0 - glob.sizeX / 2, y = 0 - glob.sizeY / 2}
	glob.score = 0
	glob.artifacts = {}
	glob.artifacts.count = 0
	glob.artifacts.lastcount = 0
	glob.artifacts.pos = {}
	glob.ticks = 0

	game.player.gui.top.add{type="button", name="restart_button", caption=gt("restart_caption1")}
	game.player.gui.top.add{type="button", name="mode_button", caption=gt("mode_caption1")}
	game.player.gui.top.add{type="button", name="score_label", caption=gt("level_caption") ..glob.score}
	game.player.gui.top.add{type="button", name="artifact_label", caption=gt("artifact_caption") ..glob.artifacts.count.."/10"}

	game.showmessagedialog(gt("intro"))

end)


game.onevent(defines.events.onguiclick, function(event)

	if event.element.name == "restart_button" then
		if game.player.gui.top.restart_button.caption == gt("restart_caption1") then
			game.player.gui.top.restart_button.caption = gt("restart_caption2")
			game.player.gui.top.mode_button.caption = gt("mode_caption1")
			game.setdaytime(0.0)
			game.freezedaytime(true)
			local seed = glob.ticks
			for i= 1, seed do
				local temp = math.random()
			end
			rebuild_level()
		else
			rebuild_level()
		end
	end

	if event.element.name == "mode_button" then
		if game.player.gui.top.mode_button.caption == gt("mode_caption1") then
			game.setdaytime(0.5)
			game.freezedaytime(true)
			game.player.gui.top.mode_button.caption = gt("mode_caption2")
		else
			game.setdaytime(0.0)
			game.freezedaytime(true)
			game.player.gui.top.mode_button.caption = gt("mode_caption1")
		end
	end

	if event.element.name == "artifact_label" then
		for i = 1, #glob.artifacts.pos do
			game.createentity{name = "flying-text", text = gt("artifact_flying"), color = {r = 1}, position = {glob.artifacts.pos[i].x, glob.artifacts.pos[i].y}}
		end
	end

end)


game.onevent(defines.events.onpickedupitem, function(event)
	if event.itemstack.name == "alien-artifact" then
		local player_x = game.player.character.position.x
		local player_y = game.player.character.position.y
		for k, pos in ipairs(glob.artifacts.pos) do
			if (math.abs(player_x - pos.x) <= 1) and (math.abs(player_y - pos.y) <= 1) then
				table.remove(glob.artifacts.pos , k)
				break
			end
		end
	end

	if glob.score == 0 then
		if glob.artifacts.count == 1 then
			game.createentity{name = "flying-text", text = gt("warning1"), color = {r = 1}, position = game.player.character.position}
		elseif glob.artifacts.count == 3 then
			game.createentity{name = "flying-text", text = gt("warning2"), color = {r = 1}, position = game.player.character.position}
		elseif glob.artifacts.count == 5 then
			game.createentity{name = "flying-text", text = gt("warning3"), color = {r = 1}, position = game.player.character.position}
		elseif glob.artifacts.count == 7 then
			game.createentity{name = "flying-text", text = gt("warning4"), color = {r = 1}, position = game.player.character.position}
		elseif glob.artifacts.count == 8 then
			game.showmessagedialog(gt("intro2"))
		end
	end
end)


game.onevent(defines.events.ontick, function(event)
	glob.ticks = glob.ticks + 1
	if ((glob.ticks % 600) == 0) and game.player.gui.top.mode_button.caption == gt("mode_caption2") then
		for i = 10, glob.sizeX do
			for j = 10, glob.sizeY do
				local creeper = math.random()
				if creeper > 0.99 then
					game.canplaceentity{name = "creeper", position = {glob.maze_origin.x + i, glob.maze_origin.y + j}}
        			game.createentity{name = "creeper", position = {glob.maze_origin.x + i, glob.maze_origin.y + j}}
        		end
			end
		end
	end

	if (glob.ticks % 60) == 0 then
		if glob.score > 0 then
			if (game.getplayer().character.getinventory(1).getitemcount("basic-bullet-magazine") + game.getplayer().character.getinventory(2).getitemcount("basic-bullet-magazine")) < 10 then
				game.player.controller.insert{name="basic-bullet-magazine", count=10}
			end
		end
		glob.artifacts.count = game.getplayer().character.getinventory(1).getitemcount("alien-artifact") + game.getplayer().character.getinventory(2).getitemcount("alien-artifact")
		game.player.gui.top.artifact_label.caption = gt("artifact_caption") ..glob.artifacts.count.."/10"
		if glob.artifacts.count > (glob.artifacts.lastcount + 2) then
			game.player.print("Cheater :D")
		end
		glob.artifacts.lastcount = glob.artifacts.count
		if glob.artifacts.count >= 10 then
			if glob.score < 15 then
				glob.score = glob.score + 1
				
				if (glob.score - 1) == 0 then
					game.showmessagedialog(gt("intro3"))
				else
					game.showmessagedialog(gt("level_caption") ..glob.score)
				end
				glob.sizeX = glob.sizeX + 30
				glob.sizeY = glob.sizeY + 30
				glob.maze_origin = {x = 0 - glob.sizeX / 2, y = 0 - glob.sizeY / 2}
				rebuild_level()
			else
				game_finished()
			end
		end
	end
end)

game.onevent(defines.events.onentitydied, function(event)
	if event.entity.name == "creeper" then
		local rnd_e = math.floor(math.random()*14)
		local rnd_p = math.floor(math.random()*32)
		game.createentity{name = "flying-text", text = gt("rnd_enemy"..rnd_e), color = {r = 1}, position = event.entity.position}
		game.createentity{name = "flying-text", text = gt("rnd_player"..rnd_p), color = {b = 1}, position = game.player.character.position}
	end
end)

function newStack()
	local meta = {
		pop = function( s )
			s.size = s.size -1
			return s[s.size +1]
		end,

		push = function( s, val )
			s.size = s.size +1
			s[s.size] = val
		end
	}

	meta.__index = meta
	local stack = { size = 0 }
	setmetatable( stack, meta )
	return stack
end


function generate_maze(size_x, size_y, origin)

	local cell_visited = {}
	local wall = {}
	for i = 1, size_x do
		cell_visited[i] = {}
		wall[i] = {}
		for j = 1, size_y do
			cell_visited[i][j] = false
			wall[i][j] = true
		end
	end

	local cell_list = newStack()

	local cx = math.ceil(math.random() * size_x / 2) * 2 - 1 				-- allways odd
	local cy = math.ceil(math.random() * size_y / 2) * 2 - 1 				-- always odd

	cell_list:push(cx)
	cell_list:push(cy)
	cell_visited[cx][cy] = true

	while (cell_list.size > 0) do
		local accessible = {}
		
		if cx > 1 then
			if cell_visited[cx - 2][cy] == false then
				table.insert(accessible, {cx - 2, cy})
			end
		end

		if cx < size_x - 1 then
			if cell_visited[cx + 2][cy] == false then
				table.insert(accessible, {cx + 2, cy})
			end
		end

		if cy > 1 then
			if cell_visited[cx][cy - 2] == false then
				table.insert(accessible, {cx, cy - 2})
			end
		end

		if cy < size_y - 1 then
			if cell_visited[cx][cy + 2] == false then
				table.insert(accessible, {cx, cy + 2})
			end
		end

		if #accessible > 0 then
			local dir = math.ceil(math.random() * #accessible)
			wall[cx][cy] = false
			
			if accessible[dir][1] > cx then
				wall[cx + 1][cy] = false
			elseif accessible[dir][1] < cx then
				wall[cx - 1][cy] = false
			elseif accessible[dir][2] > cy then
				wall[cx][cy + 1] = false
			elseif accessible[dir][2] < cy then
				wall[cx][cy - 1] = false
			end
			cx = accessible[dir][1]
			cy = accessible[dir][2]		
			cell_list:push(cx)
			cell_list:push(cy)
			cell_visited[cx][cy] = true
		elseif (cell_list.size > 0) then
			cy = cell_list:pop()
			cx = cell_list:pop()
		else
			break
		end
	end

	for i = 1, size_x do
		for j = 1, size_y do
			if wall[i][j] == true then game.createentity{name="wall", position={i + origin.x, j + origin.y}} end
		end
	end
	
	for i = 1, size_x do
		game.createentity{name="wall", position={i + origin.x, origin.y}}
	end

	for j = 1, size_y do
		game.createentity{name="wall", position={origin.x, j + origin.y}}
	end
end


function rebuild_level()

	local entities = game.findentities{{-250, -250},{250, 250}}
		for _, entity in ipairs(entities) do
			if entity.name ~= "player" then
				entity.destroy()
			end
		end

	generate_maze(glob.sizeX, glob.sizeY, glob.maze_origin)

	local walls = game.findentitiesfiltered{area = {glob.maze_origin, {glob.maze_origin.x + glob.sizeX + 1, glob.maze_origin.y + glob.sizeY + 1}}, name="wall"}
		for _, wall in ipairs(walls) do
			wall.setminable(false)
			--wall.health = 10000
			wall.setdestructible(false)
		end

		local emptyspace = false
		local x = 0
		while (emptyspace == false) do
			local firstrow = game.findentitiesfiltered{area = {{glob.maze_origin.x + x, glob.maze_origin.y + 1}, {glob.maze_origin.x + x + 0.5, glob.maze_origin.y + 1.5}}, name="wall"}
				if firstrow[1] == nil then
					local entrace = game.findentitiesfiltered{area = {{glob.maze_origin.x + x, glob.maze_origin.y}, {glob.maze_origin.x + x + 0.5, glob.maze_origin.y + 0.5}}, name="wall"}
					game.player.character.teleport(entrace[1].position)
					entrace[1].destroy()
					emptyspace = true
				end
			x = x + 1
		end
	
	if glob.score > 0 then	
		for i = 1, 6 do game.getplayer().character.getinventory(i).clear() end
			game.player.character.insert{name="pistol", count=1}
			game.player.character.insert{name="basic-bullet-magazine", count=100}
			game.player.character.insert{name="flame-thrower", count=1}
			game.player.character.insert{name="flame-thrower-ammo", count=20}

		local success = false
		for i = 10, glob.sizeX do
			for j = 10, glob.sizeY do
				local creeper = math.random()
				if creeper > 0.96 then
					success = game.canplaceentity{name = "creeper", position = {glob.maze_origin.x + i, glob.maze_origin.y + j}}
        			if success == true then
        				game.createentity{name = "creeper", position = {glob.maze_origin.x + i, glob.maze_origin.y + j}}
        			end
        		end
			end
		end
	end

	while (glob.artifacts.pos[1] ~= nil) do
		table.remove(glob.artifacts.pos)
	end

	for i = 1, 15 do
		local rnd_x = math.ceil(math.random() * (glob.sizeX - 5)) + glob.maze_origin.x
		local rnd_y = math.ceil(math.random() * (glob.sizeY - 5)) + glob.maze_origin.y
		success = false
		local item_x, item_y = 0 , 0
		while (success == false) do
			success = game.canplaceentity{name = "item-on-ground", position = {rnd_x + item_x, rnd_y + item_y}}
        	if success == true then
				game.createentity{name = "item-on-ground", stack = {name = "alien-artifact"}, position = {rnd_x + item_x, rnd_y + item_y}}
				game.createentity{name = "flying-text", text = gt("artifact_flying"), color = {r = 1}, position = {rnd_x + item_x, rnd_y + item_y}}
				table.insert(glob.artifacts.pos,{x = rnd_x + item_x, y = rnd_y + item_y})
        	end 
        	item_x = item_x + 0.25
        	item_y = item_y + 0.25
        end
	end

	glob.artifacts.count = 0
	game.player.character.health = 100
	game.player.gui.top.score_label.caption = gt("level_caption") ..glob.score
end


function game_finished()
	for i = 1, 6 do game.getplayer().character.getinventory(i).clear() end
	glob.score = 0
	local entities = game.findentities{{-250, -250},{250, 250}}
		for _, entity in ipairs(entities) do
			if entity.name ~= "player" then
				entity.destroy()
			end
		end
	game.showmessagedialog(gt("outro"))
end